import webpack from 'webpack'
import WebpackShellPlugin from 'webpack-shell-plugin'
import ExtractTextPlugin from 'extract-text-webpack-plugin'
import buildWBConfig from './webpack.base.cofig'
import { argv } from 'yargs'
import copyDir from 'copy-dir'


const type = typeof argv.env === 'string' ? argv.env : ''
let config = null

//testç¯å¢
if (/test/.test(type)) {
    let testNum = type.match(/\d+/)[0]
    config = buildWBConfig('test', testNum)
    config.webpackConfig.output.publicPath = config.baseConfig.publicPath
    config.webpackConfig.plugins = (config.webpackConfig.plugins || []).concat([
        new webpack.optimize.UglifyJsPlugin({
            compress: {
                warnings: false
            }
        }),
        new WebpackShellPlugin({
            onBuildStart: ['rm -rf build && echo "æ¸é¤buildç®å½"'],
        }),
    ])
} else if (type == 'pre' || type == 'prod') {
    if(type == 'pre'){
        //é¢åå¸ç¯å¢
        config = buildWBConfig('preProduction', 0)
    }else{
        //æ­£å¼ç¯å¢        
        config = buildWBConfig('production', 0)
    }
    config.webpackConfig.output.path += ('/' + config.baseConfig.dateFile)
    config.webpackConfig.output.filename = '[name].[chunkhash:8].js'
    config.webpackConfig.output.chunkFilename = '[name].[chunkhash:8].js'

    //cdnè·¯å¾
    config.webpackConfig.output.publicPath = config.baseConfig.publicPath

    //æ·»å JSåç¼©
    config.webpackConfig.plugins = (config.webpackConfig.plugins || []).concat([
        new ExtractTextPlugin({
            filename: '[name].[chunkhash:8].css',
            disable: false,
            allChunks: true
        }),
        new webpack.optimize.UglifyJsPlugin({
            compress: {
                warnings: false,
                drop_debugger: true,
                drop_console: true
            }
        }),
        new WebpackShellPlugin({
            onBuildStart: ['rm -rf build && echo "æ¸é¤buildç®å½"'],
        }),
    ])
} else {
    // å¼åç¯å¢
    config = buildWBConfig('development', 0)
    config.webpackConfig.devtool = 'source-map'
    config.webpackConfig.watch = true

    config.webpackConfig.output.publicPath = '/'+config.baseConfig.moduleId
    
    // copyDir.sync(projectDir + '/common/build/development/common', projectDir + '/build/development/common')    
    //webpack devServeréç½®ï¼ç»å®hostæµè¯éè¦æ·»å allowedHosts

    // config.webpackConfig.devServer = {
    //     host: '0.0.0.0',
    //     allowedHosts: []
    // }
}
export default config.webpackConfig